<?php
/**********************************************************************************
* smf_bot.php                                                                    *
***********************************************************************************
* SMFBot Project for SMF                                                          *
* =============================================================================== *
* Software Version:           SMFBot 0.1 Integration                              *
*                             ALICE Program E 0.9 Engine                          *
* Software by:                Integration by JRSofty Programming                  *
*                             Engine by: Paul Rydell / Anne Kootstra              *
* Copyright 2007 By:          JRSofty Programming for Integration                 *
*           2001-2007 by:     Program E Development Team                          *
* Support, News at:           http://www.galahtech.org                            *
*                             and                                                 *
*                             http://jrsofty1.stinkbugonline.com                  *
* Updates at:                 http://smfbot.dev.dansoftaustralia.net              *
***********************************************************************************
* This program is free software; you may redistribute it and/or modify it under   *
* the terms of the GNU/GPL                                                        *
*                                                                                 *
* This program is distributed in the hope that it is and will be useful, but      *
* WITHOUT ANY WARRANTIES; without even any implied warranty of MERCHANTABILITY    *
* or FITNESS FOR A PARTICULAR PURPOSE.                                            *
*                                                                                 *
**********************************************************************************/
	if (!defined('SMF'))
		die('Hacking attempt...');
		
	/* 
	** postTrigger function works as the interface between SMF's createPost() function and Program E system.
	*/
	
	function postTrigger($msgOptions, $topicOptions, $posterOptions){
		global $ID_MEMBER, $db_prefix, $sourcedir;
		// First we need to check if we are suppose to answer this post.
		if($posterOptions['id'] == $ID_MEMBER){
			// if the posterOptions['id'] != $ID_MEMBER then we have already sent a reply and we don't want the
			// bot to reply to itself or it will keep going, and going, and going, and going, and ... well you get the point.	

			// how many bots are installed?
			$qry = "SELECT 
					b.id, b.ID_MEMBER as botusrid, b.botname as botname, b.boards as botboard, m.emailAddress as botemail
					FROM {$db_prefix}bots as b
					LEFT JOIN {$db_prefix}members as m
					ON m.ID_MEMBER = b.ID_MEMBER
					WHERE b.enabled = 1 AND b.boards = '{$topicOptions['board']}'";
			// Currently I'll be limiting the number of boards that bots can post on as one per bot.
			$result = db_query($qry,__FILE__,__LINE__);
			if(mysql_num_rows($result) != 0){
				require_once($sourcedir . '/bot/src/respond.php');
				$sessid = session_id();
                list($botid, $botuserid, $botname, $botboard, $botemail) = mysql_fetch_array($result,MYSQL_BOTH);
					// let's build the options we need to make a valid post
					$response = reply($msgOptions['body'], $sessid, $botid);	
                    if($response->response == ''){
                        die($response->inputs . '<br>' . $response->patternsmatched . '<br>' . $response->timer);
                    }
					$botMsg['body'] = $response->response;                
					$botMsg['id'] = 0;
					$botMsg['subject'] = (substr($msgOptions['subject'],0,3) == 'RE:' ? $msgOptions['subject'] : 'RE: ' . $msgOptions['subject']);
					$botMsg['icon'] = $msgOptions['icon'];
					$botMsg['smileys_enabled'] = $msgOptions['smileys_enabled'];
					
					$botTopic = $topicOptions;
					$botTopic['mark_as_read'] = false;
					
					$botUser['email'] = $botemail;
					$botUser['ip'] = '127.0.0.1';
					$botUser['name'] = $botname;
					$botUser['update_post_count'] = true;
					$botUser['id'] = $botuserid;
					
					createPost($botMsg, $botTopic, $botUser);
				
			}
			
		}
		
	}
	


?>